var gd12 = {
init : function(evt)
{
   gd12debug.log("gd12.init starts");

   gd12.prefs.read();

   var appcontent = document.getElementById("appcontent");   // browser
   if (appcontent)
   {
       appcontent.addEventListener("load", gd12.contentLoadHandler, true);
   }

   var contextMenu = document.getElementById("contentAreaContextMenu");
   if (contextMenu)
   {
      contextMenu.addEventListener("popupshown",
                  gd12.cmPopupShownHandler, false);
   }

   window.addEventListener("keydown", gd12.keydownHandler, true);

   gd12debug.log("gd12.init ends");
},

contentLoadHandler : function(evt)
{
   gd12debug.log("gd12.contentLoadHandler starts");

   var doc = evt.originalTarget;
   if (doc instanceof HTMLDocument)
   {
      // register mouse handlers
      // we register them with content documents only because we
      // do not want the events fired when user click on menues, etc.
      doc.addEventListener("click", gd12.clickHandler, true);
      doc.addEventListener("mousemove", gd12.mousemoveHandler, true);

      // redundant. clean the inline translation flag. 
      gd12.dicInline.isTranslating = false;
   }

   gd12debug.log("gd12.contentLoadHandler ends");
},

cmPopupShownHandler : function(evt)
{
   // Wiktionary menu
   var cmItem = document.getElementById("gd12gdicCM");

   if (cmItem)
   {
      if (gd12.prefs.isGDicInContextMenu && !gd12.isInlineDicOff)
      {
         if (gContextMenu.isTextSelected)
            cmItem.hidden = false;
         else
         {
            cmItem.hidden = true;

            if (gd12.prefs.isAggressive)
            {
               // Because it takes 0.5 second to capture a hovered word,
               // we need to delay a little bit (0.6 sec) to see whether
               // to show the context menu item for a hovered word.
               window.setTimeout(function() {
                        if (gd12.hover.word && gd12.hover.word.length > 0)
                           cmItem.hidden = false;
                     },
                     600);
            }
         }
      }
      else
      {
         cmItem.hidden = true;
      }
   }

   // Translate Page menu
   var cmTItem = document.getElementById("gd12gtrnCM");

   if (cmTItem)
   {
      if (gd12.prefs.isGTransInContextMenu)
         cmTItem.hidden = false;
      else
         cmTItem.hidden = true;
   }
},

// Context menu oncommand handler
lookupSelectedOrHovered : function()
{
   if (gContextMenu.isTextSelected)
   {
      gd12.select.lookupSelected();
   }
   else if (gd12.prefs.isAggressive &&
            gd12.hover.word && gd12.hover.word.length > 0)
   {
      gd12.hover.translate();
   }
},

clickHandler : function(evt)
{
   //gd12debug.log("gd12.clickHandler starts");

   if (2 == evt.detail)
   {
      // set for gd12.select.lookupSelected()
      gd12.select.mouseX = evt.screenX;
      gd12.select.mouseY = evt.screenY;

      if (gd12.prefs.isDoubleClick)
      {
         gd12.select.lookup(evt);
      }
   }
   else if (1 == evt.detail)
   {
      // set for gd12.select.lookupSelected()
      gd12.select.mouseX = evt.screenX;
      gd12.select.mouseY = evt.screenY;

      if (gd12.prefs.isSelect)
      {
         gd12.select.lookup(evt);
      }
   }

   //gd12debug.log("gd12.clickHandler ends");
},

mousemoveHandler : function(evt)
{
   //gd12debug.log("gd12.mousemoveHandler starts");

   // feature: moving mouse away to close the popup.
   if (gd12.prefs.isMouseMoveClosePopup &&
         gd12.dicInline.isTranslating &&
         gd12.popup.popup && gd12.popup.popup.state == "open")
   {
      if (0 == gd12.popup.xWhenPopup && 0 == gd12.popup.yWhenPopup)
      {
         // first mouse movement after popup.
         gd12.popup.xWhenPopup = evt.screenX;
         gd12.popup.yWhenPopup = evt.screenY;
      }
      else
      {
         if (evt.screenX + 100 < gd12.popup.xWhenPopup
               || evt.screenX > gd12.popup.xWhenPopup + 100
               || evt.screenY + 100 < gd12.popup.yWhenPopup
               || evt.screenY > gd12.popup.yWhenPopup + 100)
         {
            // mouse has moved some distance.
            gd12.popup.close();
         }
      }
   }

   var isToCapture = false;
   var isToTranslate = false;

   if (gd12.prefs.isAggressive)
   {
      isToCapture = true;
   }

   if (gd12.prefs.isCtrlHover)
   {
      if (gd12.prefs.isCtrlShiftHover)
      {
         if (evt.ctrlKey && evt.shiftKey && !evt.altKey && !evt.metaKey)
         {
            isToCapture = true;
            isToTranslate = true;
         }
      }
      else if (gd12.prefs.isCtrlAltHover)
      {
         if (evt.ctrlKey && !evt.shiftKey && evt.altKey && !evt.metaKey)
         {
            isToCapture = true;
            isToTranslate = true;
         }
      }
      else
      {
         // Ctrl only + hover
         if (evt.ctrlKey && !evt.shiftKey && !evt.altKey && !evt.metaKey)
         {
            isToCapture = true;
            isToTranslate = true;
         }
      }
   }

   if (isToCapture)
      gd12.hover.capture(evt, isToTranslate);

   //gd12debug.log("gd12.mousemoveHandler ends");
},

keydownHandler : function(evt)
{
   //gd12debug.log("gd12.keydownHandler starts");

   if (gd12.prefs.isCtrlHover && gd12.prefs.isAggressive)
   {
      var isToTranslate = false;

      if (gd12.prefs.isCtrlShiftHover)
      {
         if ((KeyEvent.DOM_VK_CONTROL == evt.keyCode &&
                       evt.shiftKey && !evt.altKey && !evt.metaKey)
               || (KeyEvent.DOM_VK_SHIFT == evt.keyCode &&
                       evt.ctrlKey && !evt.altKey && !evt.metaKey))
         {
            isToTranslate = true;
         }
      }
      else if (gd12.prefs.isCtrlAltHover)
      {
         if ((KeyEvent.DOM_VK_CONTROL == evt.keyCode &&
                       !evt.shiftKey && evt.altKey && !evt.metaKey)
               || (KeyEvent.DOM_VK_ALT == evt.keyCode &&
                       evt.ctrlKey && !evt.shiftKey && !evt.metaKey))
         {
            isToTranslate = true;
         }
      }
      else
      {
         if (KeyEvent.DOM_VK_CONTROL == evt.keyCode &&
            !evt.shiftKey && !evt.altKey && !evt.metaKey)
         {
            isToTranslate = true;
         }
      }

      if (isToTranslate)
      {
         if (gd12.dicInline.isTranslating)
         {
            gd12debug.log("gd12.keydownHandler isTranslating");
         }
         else
         {
            gd12.hover.keydownTimeoutId = 
               window.setTimeout(gd12.hover.translate, 500);
         }
      }
      else
      {
         if (gd12.hover.keydownTimeoutId)
         {
            window.clearTimeout(gd12.hover.keydownTimeoutId);

            gd12.hover.keydownTimeoutId = null;
         }

         gd12.popup.close();
      }
   }

   //gd12debug.log("gd12.keydownHandler ends");
},

select : {
lookup : function(evt)
{
   gd12debug.log("gd12.select.lookup starts");

   var myWin = evt.originalTarget.ownerDocument.defaultView;

   gd12.select.mouseX = evt.screenX;
   gd12.select.mouseY = evt.screenY;

   gd12.select.lookupInWin(myWin);

   gd12debug.log("gd12.select.lookup ends");
},

lookupSelected : function()
{
   gd12debug.log("gd12.select.lookupSelected starts");

   var myWin = window.content;

   // gd12.select.mouseX and gd12.select.mouseY were set by
   // gd12.clickHandler()

   if (myWin)
      gd12.select.lookupInWin(myWin);

   gd12debug.log("gd12.select.lookupSelected ends");
},

lookupInWin : function(myWin)
{
   gd12debug.log("gd12.select.lookupInWin starts");

   if (myWin.location.protocol == "https:")
      gd12.dicInline.protocol = "https:";
   else
      gd12.dicInline.protocol = "http:";

   var selected = myWin.getSelection();

   gd12debug.log("gd12.select.lookupInWin selected:" + selected);

   if (selected)
   {
      var word = selected.toString();

      if (word && word.length > 0)
      {
         gd12debug.log("gd12.select.lookupInWin word:" + word);

         gd12.dicInline.translate(word, gd12.select.showPopup);
      }
   }

   gd12debug.log("gd12.select.lookupInWin ends");
},

showPopup: function()
{
   gd12.popup.open(gd12.select.mouseX, gd12.select.mouseY + 18);
},

mouseX : 0,
mouseY : 0,

},   // gd12.select

hover : {
capture : function(evt, isToTranslate)
{
   //gd12debug.log("gd12.hover.capture starts");

   gd12.hover.word = null;

   if (gd12.dicInline.isTranslating)
   {
      return;
   }

   if (!evt.rangeParent || !evt.rangeParent.nodeType ||
         (evt.rangeParent.nodeType != Node.TEXT_NODE))
   {
      return;
   }

   var myWin = evt.originalTarget.ownerDocument.defaultView;
   if (myWin.location.protocol == "https:")
      gd12.dicInline.protocol = "https:";
   else
      gd12.dicInline.protocol = "http:";

   gd12.hover.mouseX = evt.screenX;
   gd12.hover.mouseY = evt.screenY;

   if (gd12.hover.mousemoveTimeoutId)
      window.clearTimeout(gd12.hover.mousemoveTimeoutId);

   gd12.hover.mousemoveTimeoutId = window.setTimeout(
         gd12.hover.getPointedWord,
         500, 
         myWin,
         evt.rangeParent, 
         evt.rangeOffset,
         gd12.hover.mouseX,
         gd12.hover.mouseY,
         isToTranslate);

   //gd12debug.log("gd12.hover.capture ends");
},

getPointedWord : function(myWin, parnt, offset, x, y, isToTranslate)
{
   gd12debug.log("gd12.hover.getPointedWord starts: offset:" + offset
                 + ", x:" + x + ", y:" + y);

   gd12.hover.word = null;

   // check whether it is selected/highlighted
   if (myWin)
   {
      var selected = myWin.getSelection();
      
      if (selected && 1 == selected.rangeCount)
      {
         var range = selected.getRangeAt(0);
         
         if (range)
         {
            if (0 == range.comparePoint(parnt, offset)) 
            {
               // the pointed word is selected
               
               var word = selected.toString();
   
               if (word && word.length > 0)
               {
                  gd12.hover.word = word;
                  
                  if (isToTranslate)
                     gd12.dicInline.translate(gd12.hover.word, gd12.hover.showPopup);
                  
                  gd12debug.log("gd12.hover.getPointedWord word:" + word);
   
                  return;
               }
            }
         }
      }
   }
   
   // pointed word is not selected
   
   if (gd12.hover.mouseX != x || gd12.hover.mouseY != y)
   {
      gd12debug.log("gd12.hover.getPointedWord Mouse moved away");
      return;
   }

   var text = parnt.textContent;

   if (text && text.length > 0)
   {
      gd12.hover.word = gd12.hover.getWord(text, offset);

      if (isToTranslate)
         gd12.dicInline.translate(gd12.hover.word, gd12.hover.showPopup);
   }

   gd12debug.log("gd12.hover.getPointedWord ends");
},

getWord: function(text, offset)
{
   gd12debug.log("gd12.hover.getWord starts: text:" + text + ", offset:" + offset);

   var ch = text.charAt(offset);

   gd12debug.log("gd12.hover.getWord charAt(offset):" + ch);

   if (!ch || ch.length == 0 || gd12.hover.isSymbol(ch))
   {
      gd12debug.log("gd12.hover.getWord: no word");
      return null;
   }

   var len = text.length;
   var s = offset;
   var e = offset + 1;

   while (s > 0)
   {
      s--;
      
      ch = text.charAt(s);

      if (gd12.hover.isSymbol(ch))
      {
         // separator
         s++;
         break;
      }
   }

   while (e < len)
   {
      ch = text.charAt(e);

      if (gd12.hover.isSymbol(ch))
      {
         // separator
         break;
      }

      e++;
   }

   var word = text.substring(s, e);

   gd12debug.log("gd12.hover.getWord returns: " + word);

   return word;
},

isSymbol: function(ch)
{
   if (ch < 'A' ||
         (ch > 'Z' && ch <'a') ||
         (ch > 'z' && ch <= '\x7f') ||
         (ch >= '\u0080' && ch <= '\u00BF') ||
         (ch >= '\u3000' && ch <= '\u303F') ||
         (ch >= '\uFF01' && ch <= '\uFF20') ||
         (ch >= '\uFF3B' && ch <= '\uFF40') ||
         (ch >= '\uFF5B' && ch <= '\uFF5E'))
   {
      return true;
   }
   else
      return false;
},

showPopup: function()
{
   // gd12.hover.showPopup

   gd12.popup.open(gd12.hover.mouseX, gd12.hover.mouseY + 18);
},

translate: function()
{
   // gd12.hover.translate
   // after 500ms delay. we need to check the isTranslating flag again.

   if (!gd12.dicInline.isTranslating)
   {
      gd12.dicInline.translate(gd12.hover.word, gd12.hover.showPopup);
   }
},

mouseX : 0,
mouseY : 0,
mousemoveTimeoutId : null,

keydownTimeoutId : null,

word : null,
},   // gd12.hover

dicInline : {
translate: function(word, callback)
{
   gd12debug.log("gd12.dicInline.translate starts");

   if (gd12.isInlineDicOff)
      return;

   // reset
   gd12.resp.isTranslated = false;
   gd12.dicInline.word = null;
   gd12.dicInline.pendingReqCount = 0;

   if (word && word.length > 0)
   {
      word = word.replace(/^\s+|\s+$/g, "");  // trim spaces.

      gd12.dicInline.word = word;

      callback();   // ...showPopup()

      var ori = document.getElementById("gd12popupOrig");
      ori.textContent = gd12.dicInline.word;

      if (gd12.dicInline.protocol == "http:" && 
            gd12.lang.isSupportedByGTran(gd12.prefs.yourLang))
      {
         gd12.dicInline.lookupGT();
         gd12.dicInline.pendingReqCount++;
      }

      gd12.dicInline.lookupWikt(gd12.dicInline.word, true, false);
      gd12.dicInline.pendingReqCount++;

      var wordInLowerCase = gd12.dicInline.word.toLowerCase();
      if (wordInLowerCase != gd12.dicInline.word)
      {
         gd12.dicInline.lookupWikt(wordInLowerCase, true, false);
         gd12.dicInline.pendingReqCount++;
      }

      if (gd12.prefs.yourLang != "en")
      {
         // lookup english dictionary too
         gd12.dicInline.lookupWikt(gd12.dicInline.word, false, false);
         gd12.dicInline.pendingReqCount++;

         if (wordInLowerCase != gd12.dicInline.word)
         {
            gd12.dicInline.lookupWikt(wordInLowerCase, false, false);
            gd12.dicInline.pendingReqCount++;
         }
      }

      if (gd12.prefs.yourLang != "en" && gd12.prefs.isUseEnglish)
      {
         var col2 = document.getElementById("gd12popupDictEn");
         col2.style.display = "table-cell";
      }
      else
      {
         var col2 = document.getElementById("gd12popupDictEn");
         col2.style.display = "none";
      }
   }

   gd12debug.log("gd12.dicInline.translate ends");
},


lookupGT : function()
{
   //var url = "http://translate.google.com/#auto%7CGD12_YOUR_LANG%7C"
   var url = "http://translate.google.com/translate_t?hl=GD12_YOUR_LANG&langpair=auto|GD12_YOUR_LANG&tbb=1&text="
             + gd12.dicInline.word;

   url = url.replace("GD12_YOUR_LANG", gd12.prefs.yourLang);

   gd12debug.log("gd12.dicInline.lookupGT url: " + url);

   if (gd12.dicInline.urlsSent.wasSent(url)) {
      return;
   }
   
   var req = XMLHttpRequest();
   req.open("GET", url, true);
   req.onreadystatechange = function () {
      if (req.readyState == 4)
      {
         //gd12debug.log("gd12.dicInline.lookupGT resp: " + req.responseText);

         var start = req.responseText.indexOf("result_box");

         if (start > 0)
         {
            var end = req.responseText.indexOf("</span>", start);

            if (end > 0)
            {
               var ss = req.responseText.substring(start, end);

               start = ss.lastIndexOf(">");
               if (start > 0)
               {
                  start++;

                  if (end > start)
                  {
                     // we have a translation.
                     ss = ss.substring(start, end);

                     if (ss != gd12.dicInline.word)
                        document.getElementById("gd12popupTrans").textContent = ss;
                  }
               }
            }
         }

         gd12.dicInline.pendingReqCount--;
      }
   };
   req.send(null);
   
   gd12.dicInline.urlsSent.addOne(url);
},

lookupWikt : function(theWord, isToYourLang, isFurtherLookup)
{
   gd12debug.log("gd12.dicInline.lookupWikt theWord: " + theWord + ", isToYourLang:" + isToYourLang + ", isFurtherLookup:" + isFurtherLookup);
   
   var url = ((gd12.dicInline.protocol == "https:" || gd12.prefs.isAlwaysSecureWikt) ?
              gd12.dicInline.urlWikSecurePrefix : gd12.dicInline.urlWikPrefix)
             + theWord;

   if (isToYourLang)
   {
      url = url.replace("GD12_YOUR_LANG", gd12.prefs.yourLang.substr(0, 2));
   }
   else
   {
      url = url.replace("GD12_YOUR_LANG", "en");
   }

   gd12debug.log("gd12.dicInline.lookupWikt url: " + url);

   if (gd12.dicInline.urlsSent.wasSent(url)) {
      return;
   }

   var req = XMLHttpRequest();
   req.open("GET", url, true);
   req.onreadystatechange = function () {
      if (req.readyState == 4)   // done
      {
         if (isToYourLang)
         {
            var theLang = gd12.prefs.yourLang.substr(0, 2);
            if (theLang == "en")  // put it the first to speed up a little.
            {
               gd12wiktParser.processRespGDic(isToYourLang, req.responseText,
                       isFurtherLookup);
            }
            else if (theLang == "zh")
            {
               gd12wiktParser.processRespGDicZh(req.responseText, isFurtherLookup);
            }
            else if (theLang == "es")  // Spanish
            {
               gd12wiktParser.processRespGDicEs(req.responseText, isFurtherLookup);
            }
            else if (theLang == "de")  // German
            {
               gd12wiktParser.processRespGDicDe(req.responseText, isFurtherLookup);
            }
            else if (theLang == "pl")  // Polish
            {
               gd12wiktParser.processRespGDicPl(req.responseText, isFurtherLookup);
            }
            else if (theLang == "pt")  // Portuguese
            {
               gd12wiktParser.processRespGDicPt(req.responseText, isFurtherLookup);
            }
            else if (theLang == "tr")  // Turkish
            {
               gd12wiktParser.processRespGDicTr(req.responseText, isFurtherLookup);
            }
            else
            {
               gd12wiktParser.processRespGDic(isToYourLang, req.responseText,
                       isFurtherLookup);
            }
         }
         else
         {
            gd12wiktParser.processRespGDic(isToYourLang, req.responseText,
                    isFurtherLookup);
         }

         gd12.dicInline.pendingReqCount--;
         gd12.dicInline.updatePopupHint(isToYourLang);
      }
   };
   req.send(null);
   
   gd12.dicInline.urlsSent.addOne(url);
},

addOneAudioPronun : function(audioFname, audioDesc)
{
    var pronElmt = document.getElementById("gd12audioPron");

    if (pronElmt)
    {
       // query the media file location.
       var fileUrl = "http://commons.wikimedia.org/w/api.php?action=query&prop=imageinfo&iiprop=url&format=json&titles=File%3A" + audioFname;

       gd12debug.log("addOneAudioPronun: fileUrl: " + fileUrl);

       var req = XMLHttpRequest();
       req.open("GET", fileUrl, true);
       req.onreadystatechange = function () {
          if (req.readyState == 4) {
             gd12debug.log("addOneAudioPronun: responseText: " + req.responseText);

             if (req.responseText && req.responseText.length > 0) {
                var start = req.responseText.indexOf("imageinfo");
                if (start > 0) {
                   start = req.responseText.indexOf("url", start);
                   if (start > 0) {
                      start = req.responseText.indexOf("http:", start);
                      if (start > 0) {
                         var end = req.responseText.indexOf('"', start);
                         if (end > start) {
                            var uploadUrl = req.responseText.substring(start, end);

                            gd12debug.log("addOneAudioPronun: uploadUrl: " + uploadUrl);

                            if (uploadUrl.length > 0) {

                               gd12debug.log("addOneAudioPronun: pronElmt: " + pronElmt + ", audioDesc:" + audioDesc);

                               // Add one speaker icon.

                               var oneImg = document.createElementNS("http://www.w3.org/1999/xhtml", "img");

                               oneImg.src = "chrome://gd12/skin/speaker.png";

                               oneImg.setAttribute('onclick', 'document.getElementById("gd12audio").src = "' + uploadUrl + '"');

                               oneImg.setAttribute('onmouseover', 'this.src = "chrome://gd12/skin/speakerDark.png"');

                               oneImg.setAttribute('onmouseout', 'this.src = "chrome://gd12/skin/speaker.png"');

                               pronElmt.appendChild(oneImg);

                               if (audioDesc && audioDesc.length > 0) {
                                  var txt = document.createElementNS("http://www.w3.org/1999/xhtml", "span");
                                  txt.style.verticalAlign = "top";
                                  txt.style.fontSize = "80%";
                                  txt.style.marginRight = "10px";
                                  txt.textContent = audioDesc + " ";

                                  pronElmt.appendChild(txt);
                               }
                            }
                         }
                      }
                   }
                }
             }
          }
       };

       req.send(null);
    }
},

addIpaPronun : function(ipaPron)
{
    var pronElmt = document.getElementById("gd12ipaPron");

    if (pronElmt) {
       pronElmt.textContent = ipaPron;
    }
},

addOneInfo : function(oneInfo, destElementName)
{
   var strippedText = gd12wiktParser.stripContent(oneInfo);

   if (strippedText && strippedText.length > 0)
   {
      var dest = document.getElementById(destElementName);

      var aDiv = document.createElementNS("http://www.w3.org/1999/xhtml", "div");

      aDiv.textContent = '(' + strippedText + ')';

      gd12debug.log("gd12.dicInline.addOneInfo adding: " + strippedText);

      dest.appendChild(aDiv);
   }
},

addOneMeaning : function(oneMeaning, destElementName)
{
   var strippedText = gd12wiktParser.stripContent(oneMeaning);

   if (strippedText && strippedText.length > 0)
   {
      var dest = document.getElementById(destElementName);

      var oneLi = document.createElementNS("http://www.w3.org/1999/xhtml", "li");

      oneLi.textContent = strippedText;

      gd12debug.log("gd12.dicInline.addOneMeaning adding: " + strippedText);

      dest.appendChild(oneLi);
   }
},

addSeparator : function(title, destElementName)
{
   var dest = document.getElementById(destElementName);

   var p = document.createElementNS("http://www.w3.org/1999/xhtml", "p");

   p.textContent = "▾▾▾  " + title + "  ▾▾▾";
   p.style.fontWeight = "bold";

   dest.appendChild(p);
},

addTitle : function(title, language, destElementName)
{
   var dest = document.getElementById(destElementName);

   var toShow = title;

   if (language)
      toShow = title + ' (' + language + ')';

   var p = document.createElementNS("http://www.w3.org/1999/xhtml", "p");

   p.textContent = toShow;
   p.className = "gDicClassPopupDetailTitle";

   dest.appendChild(p);
},

buildMoreUrlGT : function(destLang)
{
   var url = null;

   if (gd12.dicInline.protocol == "http:")
   {
      url = "http://translate.google.com/#auto%7CGD12_YOUR_LANG%7C"
            + gd12.dicInline.word;

      url = url.replace("GD12_YOUR_LANG", destLang);
   }

   return url;
},

buildMoreUrlWik : function(destLang)
{
   var url = null;

   if (destLang == "zh-CN")
   {
      url = ((gd12.dicInline.protocol == "https:" || gd12.prefs.isAlwaysSecureWikt) ?
                "https://secure.wikimedia.org/wiktionary/zh/w/index.php?variant=zh-hans&title=" :
                "http://zh.wiktionary.org/zh-hans/")
            + gd12.dicInline.word;
   }
   else if (destLang == "zh-TW")
   {
      url = ((gd12.dicInline.protocol == "https:" || gd12.prefs.isAlwaysSecureWikt) ?
                "https://secure.wikimedia.org/wiktionary/zh/w/index.php?variant=zh-hant&title=" :
                "http://zh.wiktionary.org/zh-hant/")
            + gd12.dicInline.word;
   }
   else
   {
      destLang = destLang.substr(0, 2);
      url = ((gd12.dicInline.protocol == "https:" || gd12.prefs.isAlwaysSecureWikt) ?
                gd12.dicInline.urlMoreWikSecurePrefix :
                gd12.dicInline.urlMoreWikPrefix)
            + gd12.dicInline.word;

      url = url.replace("GD12_YOUR_LANG", destLang);
   }

   return url;
},

moreUrlOnClick : function(url)
{
   gd12.popup.close();

   var theBrowser = getBrowser();

   theBrowser.selectedTab = theBrowser.addTab(url);
},


updatePopupHint : function(isToYourLang)  //TODO: isToYourLang
{
   // Clean the spinner
   var hnt = isToYourLang ?
               document.getElementById("gd12popupHint") :
               document.getElementById("gd12popupHintEn");

   hnt.style.display = "none";
},



urlWikPrefix : "http://GD12_YOUR_LANG.wiktionary.org/w/api.php?action=query&prop=revisions&rvprop=content&redirects&converttitles&titles=",
urlMoreWikPrefix : "http://GD12_YOUR_LANG.wiktionary.org/wiki/",
urlWikSecurePrefix : "https://secure.wikimedia.org/wiktionary/GD12_YOUR_LANG/w/api.php?action=query&prop=revisions&rvprop=content&redirects&converttitles&titles=",
urlMoreWikSecurePrefix : "https://secure.wikimedia.org/wiktionary/GD12_YOUR_LANG/wiki/",
//urlGtrnPrefix : "//ajax.googleapis.com/ajax/services/language/translate?v=1.0&langpair=GD12_SRC_LANG%7CGD12_YOUR_LANG&q=",
//urlMoreGtrnPrefix : "http://translate.google.com/#GD12_SRC_LANG%7CGD12_YOUR_LANG%7C",  // https not supported

NUM_AUDIO_PRONUN_SHOWN : 8,

NUM_MEANINGS_SHOWN : 5,
numMeaningsShown : 0,
numMeaningsShownEn : 0,

isTranslating : false,

pendingReqCount : 0,

protocol : "http:",

word : null,

urlsSent : {
   addOne : function(url) {
      if (null == gd12.dicInline.urlsSent.urls) {
         gd12.dicInline.urlsSent.urls = new Array();
      }
      
      gd12.dicInline.urlsSent.urls.push(url);
   },
   
   wasSent : function(url) {
      if (!gd12.dicInline.urlsSent.urls)
         return false;
      
      for (var i = 0; i < gd12.dicInline.urlsSent.urls.length; i++) {
         if (url == gd12.dicInline.urlsSent.urls[i]) {
            return true;
         }
      }
      
      return false;
   },
   
   clear : function() {
      gd12.dicInline.urlsSent.urls = null;
   },
   
   urls : null,
},   // gd12.dicInline.urlsSent

},   // gd12.dicInline

popup : {
open : function(x, y)
{
   gd12debug.log("gd12.popup.open starts");

   if (!gd12.popup.popup)
      gd12.popup.popup = document.getElementById("gd12popup");

   if (gd12.popup.popup)
   {
      // clean up.
      gd12.popup.cleanup();

      gd12.popup.popup.openPopupAtScreen(x, y, false);
   }

   gd12debug.log("gd12.popup.open ends.");
},

close : function()
{
   gd12debug.log("gd12.popup.close starts");

   if (gd12.popup.popup)
   {
      if (gd12.popup.popup.state == "open")
         gd12.popup.popup.hidePopup();
   }

   gd12debug.log("gd12.popup.close ends");
},

on : function()
{
   gd12debug.log("gd12.popup.on starts");

   // if popup is open, stop new translation.
   // if we want to change this behavior, remember to change off() too
   gd12.dicInline.isTranslating = true;

   gd12.popup.xWhenPopup = 0;
   gd12.popup.yWhenPopup = 0;

   gd12debug.log("gd12.popup.on ends");
},

off : function()
{
   gd12debug.log("gd12.popup.off starts");

   gd12.dicInline.isTranslating = false;
   
   gd12.dicInline.urlsSent.clear();

   gd12debug.log("gd12.popup.off ends");
},

cleanup : function()
{
   var ori = document.getElementById("gd12popupOrig");
   ori.textContent = "";

   var tra = document.getElementById("gd12popupTrans");
   tra.textContent = "";

   var urlGT = gd12.dicInline.buildMoreUrlGT(gd12.prefs.yourLang);
   if (urlGT)
   {
      tra.onclick = function () {gd12.dicInline.moreUrlOnClick(urlGT);};

      tra.style.display = "inline";
   }
   else
      tra.style.display = "none";

   var puMore = document.getElementById("gd12popupMoreWik");
   var urlWik = gd12.dicInline.buildMoreUrlWik(gd12.prefs.yourLang);
   puMore.onclick = function () { gd12.dicInline.moreUrlOnClick(urlWik); };

   puMore = document.getElementById("gd12popupMoreWikEn");
   var urlWikEn = gd12.dicInline.buildMoreUrlWik("en");
   puMore.onclick = function () { gd12.dicInline.moreUrlOnClick(urlWikEn); };

   var info = document.getElementById("gd12popupInfo");
   info.textContent = "";

   info = document.getElementById("gd12popupInfoEn");
   info.textContent = "";

   var det = document.getElementById("gd12popupDetails");
   det.textContent = "";
   
   gd12.dicInline.numMeaningsShown = 0;

   det = document.getElementById("gd12popupDetailsEn");
   det.textContent = "";

   gd12.dicInline.numMeaningsShownEn = 0;

   var hnt = document.getElementById("gd12popupHint");
   hnt.style.display = "inline";

   hnt = document.getElementById("gd12popupHintEn");
   hnt.style.display = "inline";

   var pronBoxElmt = document.getElementById("gd12audioPronBox");
   var pronElmt = document.getElementById("gd12audioPron");
   if (pronElmt)
   {
      pronElmt.parentNode.removeChild(pronElmt);
   }
   pronElmt = document.createElementNS("http://www.w3.org/1999/xhtml", "div");
   pronElmt.id = "gd12audioPron";
   pronBoxElmt.appendChild(pronElmt);

   document.getElementById("gd12audio").src = '';

   document.getElementById("gd12ipaPron").textContent = "";
},

copyToClipboard : function(selected)
{
   var word = selected.toString();

   if (word.length > 0) {
      const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].
                  getService(Components.interfaces.nsIClipboardHelper);
    
      gClipboardHelper.copyString(word);
   }
},

translate : function(selected)
{
   var word = selected.toString().replace(/^\s+|\s+$/g, "");  // trim spaces.

   if (word.length > 0) {
      gd12.dicInline.urlsSent.clear();
      
      gd12.dicInline.translate(word, gd12.popup.cleanup);
   }
},

popup : null,

xWhenPopup : 0,
yWhenPopup : 0,

},  // gd12.popup

resp : {
parse : function(jsonResp)
{
   gd12debug.log("gd12.resp.parse starts: " + jsonResp);

   gd12.resp.src = null,
   gd12.resp.trans = null,
   gd12.resp.isTranslated = false;

   var jrsp;
   
   try
   {
      jrsp = JSON.parse(jsonResp);
   }
   catch (e)
   {
      gd12debug.log("gd12.resp.parse exception");
      return;
   }

   if (jrsp)
   {
      if (jrsp.responseStatus && jrsp.responseStatus == 200)
      {
         // good response.

         if (jrsp.responseData)
         {
            if (jrsp.responseData.translatedText)
            {
               gd12.resp.trans = jrsp.responseData.translatedText;

               gd12.resp.isTranslated = true;
            }

            if (jrsp.responseData.detectedSourceLanguage)
            {
               gd12.resp.src = jrsp.responseData.detectedSourceLanguage;
            }
         }
      }
   }

   gd12debug.log("gd12.resp.parse ends: isTranslated: " + gd12.resp.isTranslated);
},

src : null,   // detected source language
trans : null,

isTranslated : false,
},   // gd12.resp

translatePage : {   // gd12.translatePage
run : function()
{
   gd12debug.log("gd12.translatePage.run starts");

   if (gd12.prefs.isTransPageInNewTab &&
         "http:" == gd12.dicInline.protocol)  // secure pages only supported by inline
   {
      gd12.translatePage.runInNewTab();
   }
   else
   {
      gd12.translatePage.runInline();
   }

   gd12debug.log("gd12.translatePage.run ends");
},

runInline : function()
{
   if (!gd12.lang.isSupportedByGTran(gd12.prefs.yourLang))
      return;
   
   var doc = getBrowser().contentDocument;

   var s1 = doc.createElement("script");
   s1.type = "text/javascript";

   var scriptText = gd12.translatePage.func.replace(
                  "GD12_YOUR_LANG", gd12.prefs.yourLang);

   var scriptTextNode = doc.createTextNode(scriptText);

   s1.appendChild(scriptTextNode);

   var s2 = doc.createElement("script");
   s2.type = "text/javascript";

   s2.src = gd12.translatePage.url.replace(
         "GD12_YOUR_LANG", gd12.prefs.yourLang);

   var elm = doc.getElementsByTagName("head")[0];

   if (elm)
   {
      elm.appendChild(s1);
      elm.appendChild(s2);
   }
},

runInNewTab : function()
{
   var theBrowser = getBrowser();

   var loc = theBrowser.contentWindow.location;

   var transUrl = "http://translate.google.com/translate?sl=auto&tl=" +
                  gd12.prefs.yourLang +
                  "&u=" + encodeURIComponent(loc);

   theBrowser.selectedTab = theBrowser.addTab(transUrl);
},

func : "function googleTranslateElementInit() { var tElem = new google.translate.TranslateElement({ autoDisplay: false, pageLanguage: 'auto', includedLanguages: 'GD12_YOUR_LANG' }); setTimeout(function() { tElem.showBanner(true); }, 100);}",   // showBanner(autoTrans=true)
url : "//translate.google.com/translate_a/element.js?cb=googleTranslateElementInit&hl=GD12_YOUR_LANG",
},   // gd12.translatePage

prefs : {   // gd12.prefs
read : function()      // gd12.prefs.read
{
   gd12debug.log("gd12.prefs.read starts");

   var prefs = Components.classes["@mozilla.org/preferences-service;1"]
               .getService(Components.interfaces.nsIPrefService);
   var myprefs = prefs.getBranch("extensions.gdic_gtrans.");

   gd12.prefs.yourLang = myprefs.getCharPref("yourLanguage");
   gd12.prefs.isUseEnglish = myprefs.getBoolPref("enableUseEnglish");
   gd12.prefs.isSelect = myprefs.getBoolPref("enableSelect");
   gd12.prefs.isDoubleClick = myprefs.getBoolPref("enableDoubleClick");

   gd12.prefs.isCtrlHover = myprefs.getBoolPref("enableCtrlHover");
   gd12.prefs.isCtrlShiftHover = gd12.prefs.isCtrlHover && myprefs.getBoolPref("isCtrlShiftHover");
   gd12.prefs.isCtrlAltHover = gd12.prefs.isCtrlHover && myprefs.getBoolPref("isCtrlAltHover");

   gd12.prefs.isAggressive = myprefs.getBoolPref("aggressiveMode");
   gd12.prefs.isMouseMoveClosePopup = myprefs.getBoolPref("mouseMoveClosePopup");
   gd12.prefs.isGDicInContextMenu = myprefs.getBoolPref("gdicInContextMenu");
   gd12.prefs.isGTransInContextMenu = myprefs.getBoolPref("gtransInContextMenu");

   gd12.prefs.isAlwaysSecureWikt = myprefs.getBoolPref("alwaysSecureWikt");
   gd12.prefs.isTransPageInNewTab = myprefs.getBoolPref("transPageInNewTab");

   gd12.prefs.isDetectLangDisabled = myprefs.getBoolPref("disableAutoDetectLanguage");
   gd12.prefs.srcLang = myprefs.getCharPref("srcLanguage");

   gd12.prefs.isMyStyle = myprefs.getBoolPref("enableMyStyle");
   gd12.prefs.myStyle = myprefs.getCharPref("myStyle");

   if (gd12.prefs.yourLang.length == 0)
   {
      // try to set as the browser's language.
      var gprefs = prefs.getBranch("general.useragent.");
      if (gprefs)
      {
         var browserLang = gprefs.getCharPref("locale");

         if (browserLang)
         {
            if (browserLang == "zh-CN" || browserLang == "zh-TW")
            {
               gd12.prefs.yourLang = browserLang;
            }
            else
            {
               if (browserLang.length > 2 && browserLang.charAt(2) == "-")
               {
                  // google dictionary/translate does not
                  // recognize sub-categories.
                  gd12.prefs.yourLang = browserLang.substr(0, 2);
               }
               else
               {
                  gd12.prefs.yourLang = browserLang;
               }
            }

            gd12debug.log("gd12.prefs.read browser lang:" +
                  gd12.prefs.yourLang);

         }
      }

      // set language to english if we don't support the locale.
      if (gd12.prefs.yourLang.length < 2 ||
            !gd12.lang.isSupportedByGTran(gd12.prefs.yourLang))
      {
         gd12.prefs.yourLang = "en";
      }

      // write it to prefs so that we don't need to auto-set it again.
      myprefs.setCharPref("yourLanguage", gd12.prefs.yourLang);
   }

   gd12.prefs.applyUserStyle();

   gd12debug.log("gd12.prefs.read ends");
},

applyUserStyle : function()
{
   gd12debug.log("gd12.prefs.applyUserStyle starts");

   var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
                       .getService(Components.interfaces.nsIStyleSheetService);

   var ios = Components.classes["@mozilla.org/network/io-service;1"]
                       .getService(Components.interfaces.nsIIOService);

   if (gd12.prefs.isMyStyle)
   {
      // try apply user style

      if (gd12.prefs.myRegisteredStyle == gd12.prefs.myStyle)
      {
         gd12debug.log("gd12.prefs.applyUserStyle already regsitered");
         return;
      }

      // unregister the old user style
      if (gd12.prefs.myRegisteredStyle.length > 0)
      {
         var uri = ios.newURI(
               gd12.prefs.buildCssString(gd12.prefs.myRegisteredStyle),
               null, null);

         if(sss.sheetRegistered(uri, sss.USER_SHEET))
            sss.unregisterSheet(uri, sss.USER_SHEET);

         gd12.prefs.myRegisteredStyle = "";
      }

      // register the new user style
      if (gd12.prefs.myStyle.length > 0)
      {
         var uri = ios.newURI(
               gd12.prefs.buildCssString(gd12.prefs.myStyle),
               null, null);

         if(!sss.sheetRegistered(uri, sss.USER_SHEET))
            sss.loadAndRegisterSheet(uri, sss.USER_SHEET);

         gd12.prefs.myRegisteredStyle = gd12.prefs.myStyle;
      }

   }
   else
   {
      // remove user style

      if (gd12.prefs.myRegisteredStyle.length > 0)
      {
         var uri = ios.newURI(
               gd12.prefs.buildCssString(gd12.prefs.myRegisteredStyle),
               null, null);

         if(sss.sheetRegistered(uri, sss.USER_SHEET))
            sss.unregisterSheet(uri, sss.USER_SHEET);

         gd12.prefs.myRegisteredStyle = "";
      }
   }

   gd12debug.log("gd12.prefs.applyUserStyle ends");
},

buildCssString : function(styleStr)
{
   var cssStr = "data:text/css," +
                "@-moz-document url-prefix(chrome://) {" +
                encodeURIComponent(styleStr) +
                "}";

   return cssStr;
},

yourLang : "",
isUseEnglish : false,
isSelect : false,
isDoubleClick : true,
isCtrlHover : true,
isCtrlShiftHover : false,
isCtrlAltHover : false,
isAggressive : true,
isMouseMoveClosePopup : false,
isDetectLangDisabled : false,
srcLang : "en",

isMyStyle : false,
myStyle : "",
myRegisteredStyle : "",

isGDicInContextMenu : true,
isGTransInContextMenu : true,

isAlwaysSecureWikt : false,
isTransPageInNewTab : false,
},   // gd12.prefs

lang : {

isSupportedByGTran : function(lang)
{
   gd12debug.log("gd12.lang.isSupportedByGTran starts");

   var res = false;

   for (var i = 0; i < gd12.lang.gtranSupported.length; i++)
   {
      if (lang == gd12.lang.gtranSupported[i])
      {
         res = true;
         break;
      }
   }

   gd12debug.log("gd12.lang.isSupportedByGTran ends: " + res);

   return res;
},

gtranSupported : [
                   "ar",
                   "bg",
                   "zh-CN",
                   "zh-TW",
                   "hr",
                   "cs",
                   "nl",
                   "en",
                   "fi",
                   "fr",
                   "de",
                   "el",
                   "iw",
                   "hi",
                   "it",
                   "ko",
                   "pt",
                   "ru",
                   "sr",
                   "es",
                   "ta",
                   "th",

                   "af",
                   "sq",
                   "be",
                   "bn",
                   "ca",
                   "da",
                   "et",
                   "tl",
                   "gl",
                   "gu",
                   "ht",
                   "hu",
                   "is",
                   "id",
                   "ga",
                   "ja",
                   "lv",
                   "lt",
                   "mk",
                   "ms",
                   "mt",
                   "no",
                   "fa",
                   "pl",
                   "ro",
                   "sk",
                   "sl",
                   "sw",
                   "sv",
                   "tr",
                   "uk",
                   "ur",
                   "vi",
                   "cy",
                   "yi"
                ],
},

gdButton : {
clickHandler: function()
{
   if (gd12.gdButton.singleClickTimer)
   {
      // this is the second click of a double click.
      // cancel the handling of the first onclick event.
      clearTimeout(gd12.gdButton.singleClickTimer);
      gd12.gdButton.singleClickTimer = null;
   }
   else
   {
      // delay a little to see whether it is the first click of a double click.
      gd12.gdButton.singleClickTimer = setTimeout(function() {
               gd12.gdButton.singleClickTimer = null;
               gd12.select.lookupSelected();
            }, 500);
   }
},

doubleClickHandler: function()
{
   // toggle inline dic on/off

   gd12.isInlineDicOff = !gd12.isInlineDicOff;

   var gdbutton = document.getElementById("gd12gdbutton");

   if (gdbutton)
   {
      if (gd12.isInlineDicOff)
      {
         gdbutton.setAttribute("class",
               "toolbarbutton-1 gd12gdbuttondisabled");
      }
      else
      {
         gdbutton.setAttribute("class",
              "toolbarbutton-1 gd12gdbuttonactive");
      }
   }
},

singleClickTimer : null,

},  // gdButton


STR_ERROR : "??",

isInlineDicOff : false,   // temporary off

};

window.addEventListener("load", gd12.init, false);

