var gd12options = {

   load : function()
   {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService);
      var myprefs = prefs.getBranch("extensions.gdic_gtrans.");

      // Read parameters from Preferences.

      document.getElementById("gd12optYourLang").value =
         myprefs.getCharPref("yourLanguage");

      document.getElementById("gd12optIsUseEnglish").checked =
         myprefs.getBoolPref("enableUseEnglish");

      document.getElementById("gd12optIsSelect").checked =
         myprefs.getBoolPref("enableSelect");

      document.getElementById("gd12optIsDoubleClick").checked =
         myprefs.getBoolPref("enableDoubleClick");

      document.getElementById("gd12optIsCtrlHover").checked =
         myprefs.getBoolPref("enableCtrlHover");

      var isCtrlShiftHover = myprefs.getBoolPref("isCtrlShiftHover");
      var isCtrlAltHover = myprefs.getBoolPref("isCtrlAltHover");

      var optCtrlHoverKey = document.getElementById("gd12optCtrlHoverKey");

      if (isCtrlShiftHover)
         optCtrlHoverKey.selectedItem = document.getElementById("gd12optCtrlHoverShiftKey");
      else if (isCtrlAltHover)
         optCtrlHoverKey.selectedItem = document.getElementById("gd12optCtrlHoverAltKey");
      else
         optCtrlHoverKey.selectedItem = document.getElementById("gd12optCtrlHoverNoKey");

      document.getElementById("gd12optIsAggressive").checked =
         myprefs.getBoolPref("aggressiveMode");

      document.getElementById("gd12optIsMouseMoveClosePopup").checked =
         myprefs.getBoolPref("mouseMoveClosePopup");

      document.getElementById("gd12optIsGDicInContextMenu").checked =
         myprefs.getBoolPref("gdicInContextMenu");

      document.getElementById("gd12optIsGTransInContextMenu").checked =
         myprefs.getBoolPref("gtransInContextMenu");

      document.getElementById("gd12optIsAlwaysSecureWikt").checked =
         myprefs.getBoolPref("alwaysSecureWikt");

      document.getElementById("gd12optIsTransPageInNewTab").checked =
         myprefs.getBoolPref("transPageInNewTab");

      document.getElementById("gd12optDisableAutoDetectLanguage").checked =
         myprefs.getBoolPref("disableAutoDetectLanguage");

      document.getElementById("gd12optSrcLang").value =
         myprefs.getCharPref("srcLanguage");

      document.getElementById("gd12optIsMyStyle").checked =
         myprefs.getBoolPref("enableMyStyle");

      document.getElementById("gd12optMyStyle").value =
         myprefs.getCharPref("myStyle");
   },

   save : function()
   {
      var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService);
      var myprefs = prefs.getBranch("extensions.gdic_gtrans.");
      var defprefs = prefs.getDefaultBranch("extensions.gdic_gtrans.");

      // Write parameters to Preferences.

      this.savePrefValue(defprefs, myprefs, "gd12optYourLang", "yourLanguage", "char");

      this.savePrefValue(defprefs, myprefs, "gd12optIsUseEnglish", "enableUseEnglish", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsSelect", "enableSelect", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsDoubleClick", "enableDoubleClick", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsCtrlHover", "enableCtrlHover", "bool");

      var optCtrlHoverKey = document.getElementById("gd12optCtrlHoverKey");

      switch (optCtrlHoverKey.selectedItem.id)
      {
         case "gd12optCtrlHoverShiftKey":
            this.savePrefValueBool(defprefs, myprefs, "isCtrlShiftHover", true);
            this.savePrefValueBool(defprefs, myprefs, "isCtrlAltHover", false);

            break;

         case "gd12optCtrlHoverAltKey":
            this.savePrefValueBool(defprefs, myprefs, "isCtrlShiftHover", false);
            this.savePrefValueBool(defprefs, myprefs, "isCtrlAltHover", true);

            break;

         case "gd12optCtrlHoverNoKey":
         default:
            this.savePrefValueBool(defprefs, myprefs, "isCtrlShiftHover", false);
            this.savePrefValueBool(defprefs, myprefs, "isCtrlAltHover", false);
            break;
      }

      this.savePrefValue(defprefs, myprefs, "gd12optIsAggressive", "aggressiveMode", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsMouseMoveClosePopup", "mouseMoveClosePopup", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsGDicInContextMenu", "gdicInContextMenu", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsGTransInContextMenu", "gtransInContextMenu", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsAlwaysSecureWikt", "alwaysSecureWikt", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optIsTransPageInNewTab", "transPageInNewTab", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optDisableAutoDetectLanguage", "disableAutoDetectLanguage", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optSrcLang", "srcLanguage", "char");

      this.savePrefValue(defprefs, myprefs, "gd12optIsMyStyle", "enableMyStyle", "bool");

      this.savePrefValue(defprefs, myprefs, "gd12optMyStyle", "myStyle", "char");

      this.notifyBrowser();

      return true;
   },

   savePrefValue : function(defprefs, myprefs, elmtname, prefname, type)
   {
      switch (type)
      {
         case "bool":
         {
            var value = document.getElementById(elmtname).checked;

            if (defprefs.getBoolPref(prefname) != value)
               myprefs.setBoolPref(prefname, value);
            else if (myprefs.prefHasUserValue(prefname))
               myprefs.clearUserPref(prefname);

            break;
         }

         case "int":
         {
            var value = document.getElementById(elmtname).value;

            if (defprefs.getIntPref(prefname) != value)
               myprefs.setIntPref(prefname, value);
            else if (myprefs.prefHasUserValue(prefname))
               myprefs.clearUserPref(prefname);

            break;
         }

         case "char":
         default:
         {
            var value = document.getElementById(elmtname).value;

            if (defprefs.getCharPref(prefname) != value)
               myprefs.setCharPref(prefname, value);
            else if (myprefs.prefHasUserValue(prefname))
               myprefs.clearUserPref(prefname);

            break;
         }
      }
   },

   savePrefValueBool: function(defprefs, myprefs, prefname, value)
   {
      // set pref as true
      if (defprefs.getBoolPref(prefname) != value)
         myprefs.setBoolPref(prefname, value);
      else if (myprefs.prefHasUserValue(prefname))
         myprefs.clearUserPref(prefname);
   },

   notifyBrowser : function()
   {
      var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                  .getService(Components.interfaces.nsIWindowMediator);
      var enumerator = wm.getEnumerator("navigator:browser");
      while(enumerator.hasMoreElements()) {
         var win = enumerator.getNext();
         if (win && win.gd12)
            win.gd12.prefs.read();
      }
   }
}


