var gd12wiktParser = {

processRespGDic : function(isToYourLang, respText, isFurtherLookup)
{
   gd12debug.log("gd12wiktParser.processRespGDic resp len: " + respText.length + ", isToYourLang:" + isToYourLang + ", isFurtherLookup:" + isFurtherLookup);

   // enough shown ?
   if (isToYourLang)
   {
       if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
       {
          gd12debug.log("gd12wiktParser.processRespGDic: too much shown");
          return;
       }
   }
   else
   {
       if (gd12.dicInline.numMeaningsShownEn >= gd12.dicInline.NUM_MEANINGS_SHOWN)
       {
          gd12debug.log("gd12wiktParser.processRespGDic: too much shown");
          return;
       }
   }

   var respTitle = gd12wiktParser.withdrawTitleFromResp (respText);

   var respContent = gd12wiktParser.withdrawContentFromResp(respText);

   if (respContent && respContent.length > 0)
   {
      // append to the details field in the popup.
      var detElmtName = isToYourLang ? "gd12popupDetails" : "gd12popupDetailsEn";

      // extract lookup result from the first section of the response.
      var langDelimiter = '----';
      var unprocessed = respContent;

      while (unprocessed.length > 0)
      {
         // enough shown ?
         if (isToYourLang)
         {
             if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
                break;
         }
         else
         {
             if (gd12.dicInline.numMeaningsShownEn >= gd12.dicInline.NUM_MEANINGS_SHOWN)
               break;
         }

         var subs;

         var end = unprocessed.indexOf(langDelimiter);
         if (end > 0)
         {
            subs = unprocessed.substring(0, end);

            unprocessed = unprocessed.substr(end + langDelimiter.length);
         }
         else
         {
            subs = unprocessed;

            unprocessed = '';
         }

         var infoElmtName = isToYourLang ?  "gd12popupInfo" : "gd12popupInfoEn";

         // which language?
         var start = subs.search(/==[^=\x0a]+==[^=]/);
         if (start >= 0)
         {
            var subs = subs.substr(start);

            var langEnd = subs.indexOf("==", 3);
            if (langEnd > 0)
            {
               var langu = subs.substring(2, langEnd);

               gd12.dicInline.addTitle(respTitle, langu, detElmtName);
            }
         }
       
         if (!isFurtherLookup)
         {
             // pronunciation?
             var pronTitle = "===Pronunciation===";
       
             var pronSectionStart = subs.indexOf(pronTitle);
             if (pronSectionStart > 0)
             {
                pronSectionStart += pronTitle.length;
       
                pronSectionEnd = subs.indexOf("===", pronSectionStart);
       
                var pronSection = pronSectionEnd > 0 ?
                            subs.substring(pronSectionStart, pronSectionEnd)
                            : subs.substring(pronSectionStart);
       
                gd12wiktParser.defaultGetAudioPronunciation(pronSection);

                gd12wiktParser.defaultGetIpaPronunciation(pronSection);
             }
         }

         var meanings = gd12wiktParser.defaultGetMeanings(subs);

         if (meanings && meanings.length > 0)
         {
            //if (isFurtherLookup)
            //{
               //if (respTitle.length > 0)
               //{
                  //gd12.dicInline.addSeparator(respTitle, detElmtName);
               //}
            //}

            var furtherWords = new Array();

            for (var i = 0; i < meanings.length; ++i)
            {
               if (isToYourLang)
               {
                   if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
                      break;
               }
               else
               {
                   if (gd12.dicInline.numMeaningsShownEn >= gd12.dicInline.NUM_MEANINGS_SHOWN)
                     break;
               }

               gd12debug.log("gd12wiktParser.processRespGDic meanings[" +
                     i + "]:" + meanings[i]);

               if (meanings[i].length > 0)
               {
                  var oneMeaning = meanings[i];

                  // further lookup
                  var transforms = ["{{plural of|", "{{plural of |",
                                    "{{third-person singular of|",
                                    "{{past of|",
                                    "{{simple past of|",
                                    "{{past participle of|",
                                    "{{present participle of|",
                                    "{{comparative of|",
                                    "{{superlative of|"];

                  var j;
                  var transform = null;

                  for (j in transforms)
                  {
                     if (oneMeaning.indexOf(transforms[j]) >= 0)
                     {
                        transform = transforms[j];
                        break;
                     }
                  }
                  
                  if (isToYourLang)
                     gd12.dicInline.numMeaningsShown++;
                  else
                     gd12.dicInline.numMeaningsShownEn++;

                  if (transform)
                  {
                     var dest = oneMeaning.replace("|", ": ")
                                          .replace(/\x7b\x7b/g, "(")    // {{ to (
                                          .replace(/\x7d\x7d/g, ")");   // }} to )
                     gd12.dicInline.addOneMeaning(dest, detElmtName);

                     gd12wiktParser.furtherLookup(oneMeaning, transform, furtherWords);
                  }
                  else
                     gd12.dicInline.addOneMeaning(oneMeaning, detElmtName);
               }
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.processRespGDic ends.");
},

// Chinese
processRespGDicZh : function(respText, isFurtherLookup)
{
   gd12debug.log("gd12wiktParser.processRespGDicZh resp len: " + respText.length);

   var respTitle = gd12wiktParser.withdrawTitleFromResp (respText);

   var respContent = gd12wiktParser.withdrawContentFromResp(respText);

   if (respContent && respContent.length > 0)
   {
      var meanings = gd12wiktParser.defaultGetMeanings(respContent);

      if (!meanings || 0 == meanings.length) {
         // find the lines without any format
         meanings = new Array();

         var frags = respContent.split('\n');

         for (var j = 0; j < frags.length; j++) {
            if (frags[j][0] > '\x7f') {   // Chinese char is outside ASCII
               meanings.push(frags[j]);
            }
         }
      }

      if (meanings && meanings.length > 0)
      {
         if (isFurtherLookup)
         {
            if (respTitle.length > 0)
            {
               gd12.dicInline.addSeparator(respTitle, "gd12popupDetails");
            }
         }

         for (var i = 0; i < meanings.length; ++i)
         {
            if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
               break;

            gd12debug.log("gd12wiktParser.processRespGDicZh meanings[" +
                  i + "]:" + meanings[i]);

            if (meanings[i].length > 0)
            {
               var oneMeaning = meanings[i];

               // handle format of {{#if:   |[[   ]]}}
               // ------ search(/\{\{#if:[^\|]*\|\[\[.*\]\]\}\}/)
               if (oneMeaning.search(/\x7b\x7b#if:[^\x7c]*\x7c\x5b\x5b.*\x5d\x5d\x7d\x7d/) >= 0)
               {
                  oneMeaning = oneMeaning.replace(/\x7b\x7b#if:[^\x7c]*\x7c\x5b\x5b/g, "")
                                         .replace(/\x5d\x5d\x7d\x7d/g, "");
               }
                         // ------ search(/\-\{.*\}\-/)
               else if (oneMeaning.search(/\x2d\x7b.*\x7d\x2d/) >= 0) 
               {
                  oneMeaning = oneMeaning.replace(/\x2d\x7b/g, '')
                                         .replace(/\x7d\x2d/g, '');
               }

               if (oneMeaning && oneMeaning.length > 0) {
                  // append to the details field in the popup.
                  gd12.dicInline.addOneMeaning(oneMeaning, "gd12popupDetails");
                  gd12.dicInline.numMeaningsShown++;
               }
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.processRespGDicZh ends.");
},

// Spanish
processRespGDicEs : function(respText, isFurtherLookup)
{
   gd12debug.log("gd12wiktParser.processRespGDicEs resp len: " + respText.length);

   var respTitle = gd12wiktParser.withdrawTitleFromResp (respText);

   var respContent = gd12wiktParser.withdrawContentFromResp(respText);

   if (respContent && respContent.length > 0)
   {
      // look for meanings ...
      var meanings = null;

      // match: ;9:
      meanings = respContent.match(/;[0-9]:[^\x0a]+\x0a/g);

      if (meanings)
      {
         if (isFurtherLookup)
         {
            if (respTitle.length > 0)
            {
               gd12.dicInline.addSeparator(respTitle, "gd12popupDetails");
            }
         }

         for (var i = 0; i < meanings.length; ++i)
         {
            if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
               break;

            gd12debug.log("gd12wiktParser.processRespGDicEs meanings[" +
                  i + "]:" + meanings[i]);

            if (meanings[i].length > 3)
            {
               var oneMeaning = meanings[i].substr(3);  // rm ";9:"

               // append to the details field in the popup.
               gd12.dicInline.addOneMeaning(oneMeaning, "gd12popupDetails");
               gd12.dicInline.numMeaningsShown++;
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.processRespGDicEs ends.");
},

// German
processRespGDicDe : function(respText, isFurtherLookup)
{
   gd12debug.log("gd12wiktParser.processRespGDicDe resp len: " + respText.length);

   var respTitle = gd12wiktParser.withdrawTitleFromResp (respText);

   var respContent = gd12wiktParser.withdrawContentFromResp(respText);

   if (respContent && respContent.length > 0)
   {
      var meaningContent = "";

      var mark = "{{Bedeutungen}}";  // "meaning"

      var start = respContent.indexOf(mark);

      if (start > 0)
      {
         start += mark.length;

         meaningContent = respContent.substr(start);

         var end = meaningContent.search(/[\x0a\x0d]\x7b\x7b/);   // next "{{"

         if (end > 0)
         {
            meaningContent = meaningContent.substring(0, end);
         }
      }

      if (meaningContent && meaningContent.length > 0)
      {
         // look for meanings ...
         var meanings = null;

         // match: ;9:
         meanings = meaningContent.match(/:\[[0-9]\][^\x0a]+\x0a/g);

         if (meanings)
         {
            if (isFurtherLookup)
            {
               if (respTitle.length > 0)
               {
                  gd12.dicInline.addSeparator(respTitle, "gd12popupDetails");
               }
            }

            for (var i = 0; i < meanings.length; ++i)
            {
               if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
                  break;

               gd12debug.log("gd12wiktParser.processRespGDicDe meanings[" +
                     i + "]:" + meanings[i]);

               if (meanings[i].length > 4)
               {
                  var oneMeaning = meanings[i].substr(4);  // rm ":[9]"

                  // append to the details field in the popup.
                  gd12.dicInline.addOneMeaning(oneMeaning, "gd12popupDetails");
                  gd12.dicInline.numMeaningsShown++;
               }
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.processRespGDicDe ends.");
},

//Polish
processRespGDicPl : function(respText, isFurtherLookup)
{
   gd12debug.log("gd12wiktParser.processRespGDicPl resp len: " + respText.length);

   var respTitle = gd12wiktParser.withdrawTitleFromResp (respText);
   var respContent = gd12wiktParser.withdrawContentFromResp(respText);
   gd12debug.log("gd12wiktParser.processRespGDicPl respContent: " + respContent);

   if (respContent && respContent.length > 0)
   {
      //look for languages
      var lang_regexp = new RegExp("==\\s*(.*)\\s*\\({{(.*)}}\\).*==","g");//catch word and language
      var languages = respContent.match(lang_regexp);
      gd12debug.log("gd12wiktParser.processRespGDicPl languages: " + languages);
      for(var i=0; i < languages.length; i++)
      {
         if (isFurtherLookup && i==0 && respTitle.length > 0)
            gd12.dicInline.addSeparator(respTitle, "gd12popupDetails");

         var language = languages[i].replace(lang_regexp,"$2"); //extract from {{...}}
         var word     = languages[i].replace(lang_regexp,"$1"); //extract from == ... (\{\{
         gd12debug.log("gd12wiktParser.processRespGDicPl language [" + i + "]: " + language);
         if( language.length == 0 || language == "język polski")//skip empty and polish language
            continue;

         gd12.dicInline.addSeparator(word + " - " + language, "gd12popupDetails");

         var start = respContent.indexOf( languages[i] );
         var end;
         if( i != (languages.length-1) ) { //last language
            end = respContent.indexOf(languages[i+1],start + languages[i].length);
         }
         else {
            end = respContent.length;
         }
         var langContent = respContent.slice(start,end);
         gd12debug.log("gd12wiktParser.processRespGDicPl langContent [" + start + "-" + end + "]: " + langContent);

         //look for meanings
         var meaningContent = "";
         var mark = "{{znaczenia}}"; // {{meaning}}

         var start = langContent.indexOf(mark);
         if( start >= 0 )
         {
            start += mark.length;
            meaningContent = langContent.substr(start);

            var end = meaningContent.search(/[\x0a\x0d]\x7b\x7b/); // next "{{"
            if (end > 0)
               meaningContent = meaningContent.substring(0, end);
            gd12debug.log("gd12wiktParser.processRespGDicPl meaningContent: " + meaningContent);
         }

         if (meaningContent.length > 0)
         {
            // look for part of the sentence ...
            var parts = meaningContent.match(/^''.*''/gm);
            gd12debug.log("gd12wiktParser.processRespGDicPl parts: " + parts);

            if (parts)
            {
               for(var ii=0; ii < parts.length; ii++)
               {
                  var part = parts[ii];
                  var part_clean = part.slice(2,-2).replace(/[\[\]]/g,"").replace(/\w+\|/g,""); //remove '[[',']]' and 'word|'
                  gd12.dicInline.addOneInfo(part_clean, "gd12popupDetails");

                  meaningContent = meaningContent.substr( meaningContent.indexOf(part)+ part.length);
                  var end = meaningContent.search(/^''/m);//begining of next part
                  if( end < 0)
                     end = meaningContent.length;

                  var meanings = meaningContent.slice(0,end).match(/(\[\[\w*\]\])|(\(''(.*)''\))/g);
                  gd12debug.log("gd12wiktParser.processRespGDicPl meanings [0-"+end+"]: " + meanings);
                  if( meanings ) {
                     if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
                        break;
                     meanings = meanings.toString().replace(/'/g,"");//remove '
                     meanings = meanings.replace(/,\(/g,"(");//replace ,( to (
                     gd12.dicInline.addOneMeaning( meanings , "gd12popupDetails");
                     gd12.dicInline.numMeaningsShown++;
                  }
                  meaningContent = meaningContent.substr(end);
               }
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.processRespGDicPl ends.");
},

// Portuguese
// extract any lines that are numbered-list
processRespGDicPt : function(respText, isFurtherLookup)
{
   gd12debug.log("gd12wiktParser.processRespGDicPt resp len: " + respText.length);

   var respTitle = gd12wiktParser.withdrawTitleFromResp (respText);

   var respContent = gd12wiktParser.withdrawContentFromResp(respText);

   if (respContent && respContent.length > 0)
   {
      var meanings = gd12wiktParser.defaultGetMeanings(respContent);

      if (meanings && meanings.length > 0)
      {
         if (isFurtherLookup)
         {
            if (respTitle.length > 0)
            {
               gd12.dicInline.addSeparator(respTitle, "gd12popupDetails");
            }
         }

         for (var i = 0; i < meanings.length; ++i)
         {
            if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
               break;

            gd12debug.log("gd12wiktParser.processRespGDicPt meanings[" +
                  i + "]:" + meanings[i]);

            if (meanings[i].length > 0)
            {
               var oneMeaning = meanings[i];

               if (oneMeaning && oneMeaning.length > 0) {
                  // append to the details field in the popup.
                  gd12.dicInline.addOneMeaning(oneMeaning, "gd12popupDetails");
                  gd12.dicInline.numMeaningsShown++;
               }
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.processRespGDicPt ends.");
},

// Turkish
processRespGDicTr : function(respText, isFurtherLookup)
{
   gd12debug.log("gd12wiktParser.processRespGDicTr resp len: " + respText.length);

   var respTitle = gd12wiktParser.withdrawTitleFromResp (respText);

   var respContent = gd12wiktParser.withdrawContentFromResp(respText);

   if (respContent && respContent.length > 0)
   {
      // look for meanings ...
      var meanings = null;

      // match: :[9]
      meanings = respContent.match(/:\x5b[0-9]\x5d[^\x0a]+\x0a/g);

      if (meanings)
      {
         if (isFurtherLookup)
         {
            if (respTitle.length > 0)
            {
               gd12.dicInline.addSeparator(respTitle, "gd12popupDetails");
            }
         }

         for (var i = 0; i < meanings.length; ++i)
         {
            if (gd12.dicInline.numMeaningsShown >= gd12.dicInline.NUM_MEANINGS_SHOWN)
               break;

            gd12debug.log("gd12wiktParser.processRespGDicTr meanings[" +
                  i + "]:" + meanings[i]);

            if (meanings[i].length > 4)
            {
               var oneMeaning = meanings[i].substr(4);  // rm :[9]

               // append to the details field in the popup.
               gd12.dicInline.addOneMeaning(oneMeaning, "gd12popupDetails");
               gd12.dicInline.numMeaningsShown++;
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.processRespGDicTr ends.");
},




// =========================================================

defaultGetAudioPronunciation : function(pronSection)
{
    var audios = pronSection.match(/\x7b\x7baudio\x7c[^\x7b\x7c\x7d]+\x7cAudio[^\x7b\x7c\x7d]*\x7d\x7d/g);

    if (audios && audios.length > 0)
    {
       for (var j = 0; j < audios.length; ++j)
       {
          if (j >= gd12.dicInline.NUM_AUDIO_PRONUN_SHOWN)
             break;

          var oneAudio = audios[j];

          var audioFileStart = oneAudio.indexOf("|");
          if (audioFileStart > 0)
          {
             audioFileStart++;

             var audioFileEnd = oneAudio.indexOf("|", audioFileStart);
             if (audioFileEnd > audioFileStart)
             {
                var audioFile = oneAudio.substring(audioFileStart, audioFileEnd);

                var audioFnameEnd = audioFile.indexOf(".ogg");
                if (audioFnameEnd > 0)
                {
                   audioFnameEnd += 4;

                   var audioFname = audioFile.substring(0, audioFnameEnd);

                   audioFname = audioFname.replace(" ", "_");

                   // Get the description, e.g. (US)
                   var audioDesc = null;

                   var audioDescStart = oneAudio.indexOf("(", audioFileEnd);
                   if (audioDescStart > audioFileEnd)
                   {
                      var audioDescEnd = oneAudio.indexOf(")", audioDescStart);
                      if (audioDescEnd > audioDescStart)
                      {
                         audioDescEnd++;

                         audioDesc = " " + oneAudio.substring(audioDescStart, audioDescEnd);
                      }
                   }

                   gd12.dicInline.addOneAudioPronun(audioFname, audioDesc);

                }
             }
          }
       }
    }
},

defaultGetIpaPronunciation : function(pronSection)
{
    // {{IPA|/ˈbɪzˌnəs/}}
    // http://en.wiktionary.org/wiki/Template:IPA
    // {{IPA|pronunciation 1|[pronunciation 2]|[pronunciation 3]|[pronunciation 4]|[lang=en]}}

    var pronuns = pronSection.match(/\x7b\x7bIPA\x7c[^\x7b\x7d]+\x7d\x7d/g);

    if (pronuns)
    {
       var allPron = "";

       for (var i = 0; i < pronuns.length; ++i)
       {
          if (pronuns[i].length > 10)
          {
             var onePronStart = pronuns[i].indexOf("|");
             if (onePronStart > 0 && onePronStart + 4 < pronuns[i].length)
             {
                onePronStart++;
                var onePron = pronuns[i].substring(onePronStart, pronuns[i].length - 2);

                var onePronEnd = onePron.indexOf('|lang=');
                if (onePronEnd > 0) {
                   onePron = onePron.substring(0, onePronEnd);
                }

                if (onePron.length > 0)
                {
                   if (0 == allPron.length)
                      allPron = "IPA: " + onePron;
                   else
                      allPron += ", " + onePron;
                }
             }
          }
       }

       if (allPron && allPron.length > 0)
          gd12.dicInline.addIpaPronun(allPron);
    }
},

defaultGetMeanings : function(src)
{
   var meanings = new Array();

   var lines = src.split('\n');

   for (var i = 0; i < lines.length; i++) {
      var oneLine = lines[i];

      if (oneLine.length > 1) {
         if ('#' == oneLine[0] && '#*:;'.indexOf(oneLine[1]) < 0) {
            // match: #......\n
            // but not ##, #*, #:, #;
            meanings.push(oneLine.substr(1));  // removing #
         }
      }
   }

   // No numbered list (#....)
   // Look for bullet list (*....)
   if (0 == meanings.length) {
      for (var i = 0; i < lines.length; i++) {
         var oneLine = lines[i];

         if ('*' == oneLine[0] && '#*:;'.indexOf(oneLine[1]) < 0) {
            // match: * ......\n
            // but not *#, **, *:, *;
            meanings.push(oneLine.substr(1));  // removing *
         }
      }
   }

   return meanings;
},


withdrawTitleFromResp : function(respText)
{
   gd12debug.log("gd12wiktParser.withdrawTitleFromResp respText: " + respText);

   var reslt = "";

   if (respText && respText.length > 0)
   {
      // Withdraw between: "<page " and ">"
      var start = respText.indexOf("&lt;page ");
      if (start > 0)
      {
         start++;
         var end = respText.indexOf("&gt;", start);
         if (end > start)
         {
            var subs = respText.substring(start, end);

            var pre = "title=&quot;";
            var suf = "&quot;";

            start = subs.indexOf(pre);
            if (start >= 0)
            {
               start += pre.length;

               end = subs.indexOf(suf, start);

               if (end > start)
               {
                  reslt = subs.substring(start, end);
               }
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.withdrawTitleFromResp reslt: " + reslt);

   return reslt;
},

withdrawContentFromResp : function(respText)
{
   gd12debug.log("gd12wiktParser.withdrawContentFromResp respText: " + respText);

   var reslt = "";

   if (respText && respText.length > 0)
   {
      // Withdraw between: <span style="color:blue;">&lt;rev ... xml:space=&quot;preserve&quot;&gt;</span>
      //          and: <span style="color:blue;">&lt;/rev&gt;</span>
      // "<rev " or "<rev>"
      var start = respText.indexOf("&lt;rev ");
      if (start > 0)
         start = respText.indexOf("&gt;", start);

      if (start > 0)
      {
         start = respText.indexOf(">", start);
         if (start > 0)
         {
            start++;
            var end = respText.indexOf("&lt;/rev&gt;", start);
            if (end > start)
            {
               end = respText.lastIndexOf("<", end);

               if (end > start)
                  reslt = respText.substring(start, end);
            }
         }
      }
   }

   gd12debug.log("gd12wiktParser.withdrawContentFromResp reslt len: " + reslt.length);

   return reslt;
},

stripContent : function(inText)
{
   var outText = "";

   if (inText && inText.length > 0)
   {
      outText = inText.replace(/\x3c[^\x3c\x3e]*\x3e/g, "")    // remove <...>
                      .replace(/\x5b\x5b[^\x7c\x5b\x5d\x0a]+\x7c/g, "")  // rm [[...|
                      .replace(/\x5b\x5b/g, "")     // rm [[
                      .replace(/\x5d\x5d/g, "")     // rm ]]
                      .replace(/\x7b\x7b[^\x7b\x7d]*\x7d\x7d/g, "")  // remove {{...}} (templates)
                               //.replace(/\x7b\x7b/g, "(")    // {{ to (
                               //.replace(/\x7d\x7d/g, ")")    // }} to )
                      .replace(/'''/g, "")     // rm ''' (bold text)
                      .replace(/''/g, "")     // rm '' (italic text)
                      .replace(/^\s+|\s+$/g, "") ;  // trim spaces.
   }

   gd12debug.log("gd12wiktParser.stripContent outText len: " + outText.length);

   return gd12wiktParser.decodeHtmlEntities(outText);
},

furtherLookup : function(meaning, prefix, furtherWords)
{
   var st = meaning.indexOf(prefix);

   if (st < 0)
      return;

   st += prefix.length;

   var end = meaning.indexOf("}}", st);

   // handle the case of: {{comparative of|[[fast]]|POS=adverb}}
   var end2 = meaning.indexOf("|", st);
   if (end2 > st && end2 < end)
      end = end2;

   if (end > st)
   {
      var plainForm = meaning.slice(st, end);

      plainForm = plainForm.replace(/^\s+|\s+$/g, "")  // trim spaces.
                     .replace(/^\x22+|\x22+$/g, "")  // trim quote.
                     .replace(/^\x27+|\x27+$/g, "")  // trim single-quote.
                     .replace(/\x5b\x5b/g, "")     // rm [[
                     .replace(/\x5d\x5d/g, "");    // rm ]]

      // need further lookup?
      for (var k = 0; k < furtherWords.length; k++)
      {
         if (plainForm == furtherWords[k])  // already looked up.
            return;
      }

      furtherWords.push(plainForm);  // add to the list

      if (gd12.dicInline.numMeaningsShown < gd12.dicInline.NUM_MEANINGS_SHOWN)
      {
         gd12.dicInline.lookupWikt(plainForm, true, true);
      }

      if (gd12.prefs.yourLang != "en" &&
            (gd12.dicInline.numMeaningsShownEn < gd12.dicInline.NUM_MEANINGS_SHOWN))
      {
         // lookup english dictionary too
         gd12.dicInline.lookupWikt(plainForm, false, true);
      }
   }
},

// decode HTML entity in string
// e.g. "&amps;amp;" -> "&"
decodeHtmlEntities: function(str)
{
   if (str.indexOf("&") >= 0)
   {
      var div = getBrowser().contentDocument.createElement("div");
      div.innerHTML = str;
      var s = div.textContent;
      div.innerHTML = s;
      return div.textContent;
   }

   return str;
},

};

